import request from '../utils/request'
import getAPI from '../config/apis'

export default {
    namespaced: true,
    state: {
      usercode: '',
    },
    mutations: {
      updateGetCode(state, usercode) {
        state.usercode = usercode
      }
    },
    actions: {
        getGetCode({ commit }, params) { 
        return new Promise((resolve, reject) => {
          request({ ...getAPI('getcode.get',{code: params.usercode}) }).then((data) => {
            commit('updateGetCode', data)
            resolve()            
          }).catch(reject)
        });
      },
    }
  }