import axios from 'axios'
// import loadding from './loadding'

const Axios = axios.create({
  timeout: 60000,
  responseType: 'json',
  withCredentials: true,
  queryData: {},
  urlData: {},
  headers: {
    'Content-Type': 'multipart/form-data'
  }
})

// const UrlSearch = (urls) => {
//   let url = urls; // 获取url中"?"符后的字串
//   let theRequest = {};
//   if (url.indexOf("?") !== -1) {
//     let str = url.substr(1);
//     let strs = str.split("&");
//     for (var i = 0; i < strs.length; i++) {
//       theRequest[strs[i].split("=")[0]] = unescape(strs[i].split("=")[1]);
//     }
//   }
//   return theRequest;
// }

export default function request(config) {
  return new Promise((resolve, reject) => {
    const { query, data, ...conf } = config;
    const params = query;
    const formHead = { 'content-type': "multipart/form-data;charset=UTF-8" }
    const fmtData = new FormData()

    if (data) {
      Object.keys(data).forEach((k) => {
        const val = data[k]

        if (Array.isArray(val)) {
          val.forEach((v) => {
            fmtData.append(k, v)
          })
        } else {
          fmtData.append(k, val)
        }
      })
    }

    // const id = loadding.start()
    Axios({
      params,
      data: !data ? undefined : fmtData,
      headers: {
        ...formHead
      },
      ...conf,
      withCredentials: true,
    }).then((response) => {
      const data = response.data;
      // loadding.stop(id);
      // window.console.log(UrlSearch(location.search).code)
      if (data.result) {
        resolve(data);
      } else if (data.code === 401) {
        // setTimeout(() => {
          getCode(data.appId)
        // }, 5000);
      }else if(data.code === 402) {
        this.$router.push({
          name: "transferpage",
        });
      }else {
        reject('请求数据失败');
      }
    }).catch((error) => {
      // console.error(error);
      // loadding.stop(id);

      reject(error.message);
    });
  });
}

const wechatConfig = {
  redirect_uri: encodeURIComponent(window.location.href),
  response_type: "code",
  scope: "snsapi_userinfo",
  state: "12313"
}

export function getCode(appid) {
  let url = `https://open.weixin.qq.com/connect/oauth2/authorize?appid=${appid}&redirect_uri=${
    wechatConfig.redirect_uri
    }&response_type=${wechatConfig.response_type}&scope=${wechatConfig.scope}&state=${
      wechatConfig.state
    }#wechat_redirect`;
  window.location.href = url;
}